var jQuery   = require('jquery')
,   document = require('browser/document')
,   window   = require('browser/window')
;

jQuery.support = {};

var root = document.documentElement,
	script = document.createElement("script"),
	div = document.createElement("div"),
	id = "script" + jQuery.now();

div.style.display = "none";
div.innerHTML = "   <link/><table></table><a href='/a' style='color:red;float:left;opacity:.55;'>a</a><input type='checkbox'/>";

var all = div.getElementsByTagName("*"),
	a = div.getElementsByTagName("a")[0],
	select = document.createElement("select"),
	opt = select.appendChild( document.createElement("option") );

// Can't get basic test support
if ( !all || !all.length || !a ) {
	return;
}

jQuery.support = {
	// IE strips leading whitespace when .innerHTML is used
	leadingWhitespace: div.firstChild.nodeType === 3,

	// Make sure that tbody elements aren't automatically inserted
	// IE will insert them into empty tables
	tbody: !div.getElementsByTagName("tbody").length,

	// Make sure that link elements get serialized correctly by innerHTML
	// This requires a wrapper element in IE
	htmlSerialize: !!div.getElementsByTagName("link").length,

	// Get the style information from getAttribute
	// (IE uses .cssText insted)
	style: /red/.test( a.getAttribute("style") ),

	// Make sure that URLs aren't manipulated
	// (IE normalizes it by default)
	hrefNormalized: a.getAttribute("href") === "/a",

	// Make sure that element opacity exists
	// (IE uses filter instead)
	// Use a regex to work around a WebKit issue. See #5145
	opacity: /^0.55$/.test( a.style.opacity ),

	// Verify style float existence
	// (IE uses styleFloat instead of cssFloat)
	cssFloat: !!a.style.cssFloat,

	// Make sure that if no value is specified for a checkbox
	// that it defaults to "on".
	// (WebKit defaults to "" instead)
	checkOn: div.getElementsByTagName("input")[0].value === "on",

	// Make sure that a selected-by-default option has a working selected property.
	// (WebKit defaults to false instead of true, IE too, if it's in an optgroup)
	optSelected: opt.selected,

	// Will be defined later
	deleteExpando: true,
	optDisabled: false,
	checkClone: false,
	scriptEval: false,
	noCloneEvent: true,
	boxModel: null,
	inlineBlockNeedsLayout: false,
	shrinkWrapBlocks: false,
	reliableHiddenOffsets: true
};

// Make sure that the options inside disabled selects aren't marked as disabled
// (WebKit marks them as diabled)
select.disabled = true;
jQuery.support.optDisabled = !opt.disabled;

script.type = "text/javascript";
try {
	script.appendChild( document.createTextNode( "window." + id + "=1;" ) );
} catch(e) {}

root.insertBefore( script, root.firstChild );

// Make sure that the execution of code works by injecting a script
// tag with appendChild/createTextNode
// (IE doesn't support this, fails, and uses .text instead)
if ( window[ id ] ) {
	jQuery.support.scriptEval = true;
	delete window[ id ];
}

// Test to see if it's possible to delete an expando from an element
// Fails in Internet Explorer
try {
	delete script.test;

} catch(e) {
	jQuery.support.deleteExpando = false;
}

root.removeChild( script );

if ( div.attachEvent && div.fireEvent ) {
	div.attachEvent("onclick", function click() {
		// Cloning a node shouldn't copy over any
		// bound event handlers (IE does this)
		jQuery.support.noCloneEvent = false;
		div.detachEvent("onclick", click);
	});
	div.cloneNode(true).fireEvent("onclick");
}

div = document.createElement("div");
div.innerHTML = "<input type='radio' name='radiotest' checked='checked'/>";

var fragment = document.createDocumentFragment();
fragment.appendChild( div.firstChild );

// WebKit doesn't clone checked state correctly in fragments
jQuery.support.checkClone = fragment.cloneNode(true).cloneNode(true).lastChild.checked;

// Figure out if the W3C box model works as expected
// document.body must exist before we can do this
jQuery(function() {
	var div = document.createElement("div");
	div.style.width = div.style.paddingLeft = "1px";

	document.body.appendChild( div );
	jQuery.boxModel = jQuery.support.boxModel = div.offsetWidth === 2;

	if ( "zoom" in div.style ) {
		// Check if natively block-level elements act like inline-block
		// elements when setting their display to 'inline' and giving
		// them layout
		// (IE < 8 does this)
		div.style.display = "inline";
		div.style.zoom = 1;
		jQuery.support.inlineBlockNeedsLayout = div.offsetWidth === 2;

		// Check if elements with layout shrink-wrap their children
		// (IE 6 does this)
		div.style.display = "";
		div.innerHTML = "<div style='width:4px;'></div>";
		jQuery.support.shrinkWrapBlocks = div.offsetWidth !== 2;
	}

	div.innerHTML = "<table><tr><td style='padding:0;display:none'></td><td>t</td></tr></table>";
	var tds = div.getElementsByTagName("td");

	// Check if table cells still have offsetWidth/Height when they are set
	// to display:none and there are still other visible table cells in a
	// table row; if so, offsetWidth/Height are not reliable for use when
	// determining if an element has been hidden directly using
	// display:none (it is still safe to use offsets if a parent element is
	// hidden; don safety goggles and see bug #4512 for more information).
	// (only IE 8 fails this test)
	jQuery.support.reliableHiddenOffsets = tds[0].offsetHeight === 0;

	tds[0].style.display = "";
	tds[1].style.display = "none";

	// Check if empty table cells still have offsetWidth/Height
	// (IE < 8 fail this test)
	jQuery.support.reliableHiddenOffsets = jQuery.support.reliableHiddenOffsets && tds[0].offsetHeight === 0;
	div.innerHTML = "";

	document.body.removeChild( div ).style.display = "none";
	div = tds = null;
});

// Technique from Juriy Zaytsev
// http://thinkweb2.com/projects/prototype/detecting-event-support-without-browser-sniffing/
var eventSupported = function( eventName ) {
	var el = document.createElement("div");
	eventName = "on" + eventName;

	var isSupported = (eventName in el);
	if ( !isSupported ) {
		el.setAttribute(eventName, "return;");
		isSupported = typeof el[eventName] === "function";
	}
	el = null;

	return isSupported;
};

jQuery.support.submitBubbles = eventSupported("submit");
jQuery.support.changeBubbles = eventSupported("change");

// release memory in IE
root = script = div = all = a = null;
